VTK: vtkLabelHierarchyCompositeIterator Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkLabelHierarchyCompositeIterator Class Reference

Iterator over sub-iterators. More...

`#include <vtkLabelHierarchyCompositeIterator.h>`

Inheritance diagram for vtkLabelHierarchyCompositeIterator:
[legend]
Collaboration diagram for vtkLabelHierarchyCompositeIterator:
[legend]

## Public Types
typedef vtkLabelHierarchyIterator | Superclass
Public Types inherited from vtkLabelHierarchyIterator
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkLabelHierarchyCompositeIterator * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | AddIterator (vtkLabelHierarchyIterator *it)
| Adds a label iterator to this composite iterator. More...
virtual void | AddIterator (vtkLabelHierarchyIterator *it, int count)
virtual void | ClearIterators ()
| Remove all iterators from this composite iterator. More...
void | Begin (vtkIdTypeArray *) override
| Initializes the iterator. More...
void | Next () override
| Advance the iterator. More...
bool | IsAtEnd () override
| Returns true if the iterator is at the end. More...
vtkIdType | GetLabelId () override
| Retrieves the current label id. More...
vtkLabelHierarchy * | GetHierarchy () override
| Retrieve the current label hierarchy. More...
void | GetNodeGeometry (double ctr[3], double &size) override
| Retrieve the coordinates of the center of the current hierarchy node and the size of the node. More...
void | BoxNode () override
| Not implemented. More...
void | BoxAllNodes (vtkPolyData *) override
| Not implemented. More...
Public Member Functions inherited from vtkLabelHierarchyIterator
vtkLabelHierarchyIterator * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | GetPoint (double x[3])
| Retrieves the current label location. More...
virtual void | GetSize (double sz[2])
| Retrieves the current label size. More...
virtual void | GetBoundedSize (double sz[2])
| Retrieves the current label maximum width in world coordinates. More...
virtual int | GetType ()
| Retrieves the current label type. More...
virtual vtkStdString | GetLabel ()
| Retrieves the current label string. More...
virtual double | GetOrientation ()
| Retrieves the current label orientation. More...
virtual void | SetTraversedBounds (vtkPolyData *)
| Sets a polydata to fill with geometry representing the bounding boxes of the traversed octree nodes. More...
virtual void | SetAllBounds (int)
| Set/get whether all nodes in the hierarchy should be added to the TraversedBounds polydata or only those traversed. More...
virtual int | GetAllBounds ()
| Set/get whether all nodes in the hierarchy should be added to the TraversedBounds polydata or only those traversed. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkLabelHierarchyCompositeIterator * | SafeDownCast (vtkObjectBase *o)
static vtkLabelHierarchyCompositeIterator * | New ()
Static Public Member Functions inherited from vtkLabelHierarchyIterator
static vtkTypeBool | IsTypeOf (const char *type)
static vtkLabelHierarchyIterator * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkLabelHierarchyCompositeIterator ()
| ~vtkLabelHierarchyCompositeIterator () override
Protected Member Functions inherited from vtkLabelHierarchyIterator
| vtkLabelHierarchyIterator ()
| ~vtkLabelHierarchyIterator () override
void | BoxNodeInternal3 (const double *ctr, double sz)
void | BoxNodeInternal2 (const double *ctr, double sz)
virtual void | SetHierarchy (vtkLabelHierarchy *h)
| The hierarchy being traversed by this iterator. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
Internal * | Implementation
Protected Attributes inherited from vtkLabelHierarchyIterator
vtkLabelHierarchy * | Hierarchy
vtkPolyData * | TraversedBounds
double | BoundsFactor
int | AllBounds
int | AllBoundsRecorded
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Iterator over sub-iterators.

Iterates over child iterators in a round-robin order. Each iterator may have its own count, which is the number of times it is repeated until moving to the next iterator.

For example, if you initialize the iterator with

    it->AddIterator(A, 1);
    it->AddIterator(B, 3);

The order of iterators will be A,B,B,B,A,B,B,B,...

Definition at line 32 of file vtkLabelHierarchyCompositeIterator.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkLabelHierarchyIterator vtkLabelHierarchyCompositeIterator::Superclass

Definition at line 35 of file vtkLabelHierarchyCompositeIterator.h.

## Constructor & Destructor Documentation

## ◆ vtkLabelHierarchyCompositeIterator()

vtkLabelHierarchyCompositeIterator::vtkLabelHierarchyCompositeIterator | ( |  | ) |
| protected

## ◆ ~vtkLabelHierarchyCompositeIterator()

vtkLabelHierarchyCompositeIterator::~vtkLabelHierarchyCompositeIterator | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkLabelHierarchyCompositeIterator::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkLabelHierarchyCompositeIterator::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkLabelHierarchyIterator.

## ◆ SafeDownCast()

static vtkLabelHierarchyCompositeIterator* vtkLabelHierarchyCompositeIterator::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkLabelHierarchyCompositeIterator::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkLabelHierarchyIterator.

## ◆ NewInstance()

vtkLabelHierarchyCompositeIterator* vtkLabelHierarchyCompositeIterator::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkLabelHierarchyCompositeIterator::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ New()

static vtkLabelHierarchyCompositeIterator* vtkLabelHierarchyCompositeIterator::New | ( |  | ) |
| static

## ◆ AddIterator() [1/2]

virtual void vtkLabelHierarchyCompositeIterator::AddIterator | ( | vtkLabelHierarchyIterator * | it | ) |
| inlinevirtual

Adds a label iterator to this composite iterator.

The second optional argument is the number of times to repeat the iterator before moving to the next one round-robin style. Default is 1.

Definition at line 44 of file vtkLabelHierarchyCompositeIterator.h.

## ◆ AddIterator() [2/2]

virtual void vtkLabelHierarchyCompositeIterator::AddIterator | ( | vtkLabelHierarchyIterator * | it,
|  | int | count
| ) |  |
| virtual

## ◆ ClearIterators()

virtual void vtkLabelHierarchyCompositeIterator::ClearIterators | ( |  | ) |
| virtual

Remove all iterators from this composite iterator.

## ◆ Begin()

void vtkLabelHierarchyCompositeIterator::Begin | ( | vtkIdTypeArray * |  | ) |
| overridevirtual

Initializes the iterator.

lastLabels is an array holding labels which should be traversed before any other labels in the hierarchy. This could include labels placed during a previous rendering or a label located under the mouse pointer. You may pass a null pointer.

Reimplemented from vtkLabelHierarchyIterator.

## ◆ Next()

void vtkLabelHierarchyCompositeIterator::Next | ( |  | ) |
| overridevirtual

Advance the iterator.

Reimplemented from vtkLabelHierarchyIterator.

## ◆ IsAtEnd()

bool vtkLabelHierarchyCompositeIterator::IsAtEnd | ( |  | ) |
| overridevirtual

Returns true if the iterator is at the end.

Reimplemented from vtkLabelHierarchyIterator.

## ◆ GetLabelId()

vtkIdType vtkLabelHierarchyCompositeIterator::GetLabelId | ( |  | ) |
| overridevirtual

Retrieves the current label id.

Reimplemented from vtkLabelHierarchyIterator.

## ◆ GetHierarchy()

vtkLabelHierarchy* vtkLabelHierarchyCompositeIterator::GetHierarchy | ( |  | ) |
| overridevirtual

Retrieve the current label hierarchy.

Reimplemented from vtkLabelHierarchyIterator.

## ◆ GetNodeGeometry()

void vtkLabelHierarchyCompositeIterator::GetNodeGeometry | ( | double | ctr[3],
|  | double & | size
| ) |  |
| overridevirtual

Retrieve the coordinates of the center of the current hierarchy node and the size of the node.

Nodes are n-cubes, so the size is the length of any edge of the cube. This is used by BoxNode().

Implements vtkLabelHierarchyIterator.

## ◆ BoxNode()

void vtkLabelHierarchyCompositeIterator::BoxNode | ( |  | ) |
| inlineoverridevirtual

Not implemented.

Reimplemented from vtkLabelHierarchyIterator.

Definition at line 91 of file vtkLabelHierarchyCompositeIterator.h.

## ◆ BoxAllNodes()

void vtkLabelHierarchyCompositeIterator::BoxAllNodes | ( | vtkPolyData * |  | ) |
| inlineoverridevirtual

Not implemented.

Reimplemented from vtkLabelHierarchyIterator.

Definition at line 96 of file vtkLabelHierarchyCompositeIterator.h.

## Member Data Documentation

## ◆ Implementation

Internal* vtkLabelHierarchyCompositeIterator::Implementation
| protected

Definition at line 103 of file vtkLabelHierarchyCompositeIterator.h.

The documentation for this class was generated from the following file:

- Rendering/Label/vtkLabelHierarchyCompositeIterator.h